Virtualization in EJ2 JavaScript File Manager control

6 Mar 20255 minutes to read

The File Manager control’s UI virtualization allows for the dynamic loading of a large number of directories and files in both the details view and large icons view without degrading performance.

Module Injection

To use UI virtualization, you must import the Virtualization module from the ej2-filemanager package and inject it using the FileManager.Inject() function.

import { FileManager, Virtualization } from '@syncfusion/ej2-filemanager';

FileManager.Inject(Virtualization);

Enable Virtualization

The virtualization of the File Manager control is based on the height and width of the viewport. The items will be loaded in both large icons view and details view based on the viewport size.

To enable virtualization, you must set the enableVirtualization property to true.

In the example below, a sizable collection of files can be found in the folders Documents and Text Documents.

var hostUrl = 'https://ej2-aspcore-service.azurewebsites.net/';
// inject feature modules of the File Manager
ej.filemanager.FileManager.Inject(ej.filemanager.DetailsView, ej.filemanager.Toolbar, ej.filemanager.NavigationPane, ej.filemanager.enableVirtualization);
// initialize File Manager control
var filemanagerInstance = new ej.filemanager.FileManager({
    ajaxSettings: {
        url: hostUrl + 'api/Virtualization/FileOperations',
        getImageUrl: hostUrl + 'api/Virtualization/GetImage',
        uploadUrl: hostUrl + 'api/Virtualization/Upload',
        downloadUrl: hostUrl + 'api/Virtualization/Download'
    },
    view: 'Details',
    enableVirtualization: true,
    beforeSend: function (args) {
        args.ajaxSettings.beforeSend = function (args) {
            args.httpRequest.setRequestHeader('Authorization', 'FileBrowser');
        };
    },
    beforeImageLoad: function (args) {
        args.imageUrl = args.imageUrl + '&rootName=' + 'FileBrowser';
    },
    beforeDownload: function (args) {
        args.data.rootFolderName = 'FileBrowser';
    },
    height: '380px'
});

// render initialized File Manager
filemanagerInstance.appendTo('#filemanager');
<!DOCTYPE html>
<html lang="en">

<head>
  <title>Essential JS 2 File Manager</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="description" content="Essential JS 2 File Manager Control">
  <meta name="author" content="Syncfusion">
  <link href="index.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-base/styles/material.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-inputs/styles/material.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-popups/styles/material.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-buttons/styles/material.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-splitbuttons/styles/material.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-layouts/styles/material.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-navigations/styles/material.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-grids/styles/material.css" rel="stylesheet">
  <link href="https://cdn.syncfusion.com/ej2/29.1.33/ej2-filemanager/styles/material.css" rel="stylesheet">
  <script src="https://cdn.syncfusion.com/ej2/29.1.33/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
  <div id="filemanager"></div>

  <script>
    var ele = document.getElementById('container');
    if (ele) {
      ele.style.visibility = "visible";
    }   
  </script>
  <script src="index.js" type="text/javascript"></script>
</body>

</html>
#container {
    visibility: hidden;
  }
  
  #loader {
    color: #008cff;
    height: 40px;
    width: 30%;
    position: absolute;
    top: 45%;
    left: 45%;
  }

Limitations for Virtualization

  • Programmatic selection using the selectAll method is not supported with virtual scrolling.
  • The keyboard shortcut CTRL+A will only select the files and directories that are currently visible within the viewport, rather than selecting all files and directories in the entire directory tree.
  • Selected file items are not maintained while scrolling, considering the performance of the control.

Virtualization in React File Manager component

20 Jan 202510 minutes to read

File Manager’s UI virtualization allows you for the dynamic loading of a large number of directories and files in both the detailsView and largeIconsView without degrading its performance.

Module Injection

In order to use UI Virtualization, you need to inject its virtualization service in the App. This modules should be injected into the File Manager using the Inject directive.

import { FileManagerComponent, Inject, Virtualization } from '@syncfusion/ej2-react-filemanager';
import * as React from 'react';

function App() {
    let hostUrl: string = "https://ej2-aspcore-service.azurewebsites.net/";
    return (
            // specifies the tag to render the File Manager component
            <FileManagerComponent id="filemanager" ajaxSettings={{
                    url: hostUrl + "api/FileManager/FileOperations",
                    getImageUrl: hostUrl + "api/FileManager/GetImage",
                    uploadUrl: hostUrl + 'api/FileManager/Upload',
                    downloadUrl: hostUrl + 'api/FileManager/Download'
                }} enableVirtualization={true}>
                    <Inject services={[Virtualization]}/>
                </FileManagerComponent>
        );
}
export default App;

Enable Virtualization

The virtualization of the File Manager component is based on the height and width of the viewport. The items will be loaded in both largeIconsView and detailsView based on the viewport size.

In order to enable virtualization, you must set the enableVirtualization property to true.

In the instance below, a sizable collection of files can be found in the folders Documents and Text Documents.

import { FileManagerComponent, Inject, NavigationPane, DetailsView, Toolbar, Virtualization } from '@syncfusion/ej2-react-filemanager';
import * as React from 'react';
/**
 * File Manager virtualization feature sample
 */
function App() {
    let hostUrl = "https://ej2-aspcore-service.azurewebsites.net/";
    function onBeforeSend(args) {
        args.ajaxSettings.beforeSend = function (args) {
            args.httpRequest.setRequestHeader('Authorization', 'FileBrowser');
        };
    }
    function beforeImageLoad(args) {
        args.imageUrl = args.imageUrl + '&rootName=' + 'FileBrowser';
    }
    function beforeDownload(args) {
        args.data.rootFolderName = 'FileBrowser';
    }
    return (<div>
            <div className="control-section">
                <FileManagerComponent id="filemanager" height="375px" 
                    ajaxSettings={{
                        url: hostUrl + "api/Virtualization/FileOperations",
                        getImageUrl: hostUrl + "api/Virtualization/GetImage",
                        uploadUrl: hostUrl + 'api/Virtualization/Upload',
                        downloadUrl: hostUrl + 'api/Virtualization/Download'
                    }} 
                    view={"Details"} 
                    enableVirtualization={true} 
                    beforeSend={onBeforeSend.bind(this)} 
                    beforeImageLoad={beforeImageLoad.bind(this)} 
                    beforeDownload={beforeDownload.bind(this)}>
                    <Inject services={[NavigationPane, DetailsView, Toolbar, Virtualization]}/>
                </FileManagerComponent>
            </div>
        </div>);
}
export default App;
import { FileManagerComponent, Inject, NavigationPane, DetailsView, Toolbar, Virtualization } from '@syncfusion/ej2-react-filemanager';
import * as React from 'react';
/**
 * File Manager virtualization feature sample
 */
function App() {

    let hostUrl: string = "https://ej2-aspcore-service.azurewebsites.net/";
    function onBeforeSend(args) {
        args.ajaxSettings.beforeSend = function (args) {
            args.httpRequest.setRequestHeader('Authorization', 'FileBrowser');
        };
    }
    function beforeImageLoad(args) {
        args.imageUrl = args.imageUrl + '&rootName=' + 'FileBrowser';
    }
    function beforeDownload(args) {
        args.data.rootFolderName = 'FileBrowser';
    }
    return(
        <div>
            <div className="control-section">
                <FileManagerComponent id="filemanager" height="375px" 
                    ajaxSettings = {{
                        url: hostUrl + "api/Virtualization/FileOperations",
                        getImageUrl: hostUrl + "api/Virtualization/GetImage",
                        uploadUrl: hostUrl + 'api/Virtualization/Upload',
                        downloadUrl: hostUrl + 'api/Virtualization/Download'
                    }}
                    view = {"Details"}
                    enableVirtualization = {true}
                    beforeSend={onBeforeSend.bind(this)}
                    beforeImageLoad={beforeImageLoad.bind(this)}
                    beforeDownload={beforeDownload.bind(this)}>
                <Inject services={[ NavigationPane, DetailsView, Toolbar, Virtualization]} />
                </FileManagerComponent>
            </div>
        </div>
    );
};
export default App;
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import App from './App';
ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import App from './App';

ReactDOM.render( <App />, document.getElementById('root') as HTMLElement);

Limitations for Virtualization

  • Programmatic selection using the selectAll method is not supported with virtual scrolling.

  • The keyboard shortcut CTRL+A will only select the files and directories that are currently visible within the viewport, rather than selecting all files and directories in the entire directory tree.

  • Selected file items are not maintained while scrolling, considering the performance of the component.

Virtualization in Angular File Manager component

10 Jan 20254 minutes to read

File Manager’s UI virtualization allows for the dynamic loading of a large number of directories and files in both the detailsView and largeIconsView without degrading its performance.

Module Injection

In order to use UI Virtualization, you need to import VirtualizationService module in the AppModule and it should be injected into the provider section as follows

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { FileManagerComponent, VirtualizationService } from '@syncfusion/ej2-angular-filemanager';

@NgModule({
    imports: [
        BrowserModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent],
    providers: [VirtualizationService]
})
export class AppModule { }

Enable Virtualization

The virtualization of the File Manager component is based on the height and width of the viewport. The items will be loaded in both largeIconsView and detailsView based on the viewport size.

In order to enable virtualization, you must set the enableVirtualization property to true.

The example below demonstrates a large collection of files in the ‘Documents’ and ‘Text Documents’ folders.

import { BrowserModule } from '@angular/platform-browser'
import { NgModule } from '@angular/core'
import { FileManagerModule, NavigationPaneService, ToolbarService, DetailsViewService, VirtualizationService } from '@syncfusion/ej2-angular-filemanager'
import { Component, ViewEncapsulation } from '@angular/core';
/**
 * File Manager virtualization feature sample
 */

@Component({
    imports: [FileManagerModule,],
    standalone: true,
    selector: 'app-root',
    styleUrls: ['./app.component.css'],
    templateUrl: './default.html',
    encapsulation: ViewEncapsulation.None,
    providers: [NavigationPaneService, ToolbarService, DetailsViewService, VirtualizationService]
})

export class AppComponent {
    public ajaxSettings?: object;
    public view?: string;
    public hostUrl: string = 'https://ej2-aspcore-service.azurewebsites.net/';
    public ngOnInit(): void {
        this.ajaxSettings = {
            url: this.hostUrl + 'api/Virtualization/FileOperations',
            getImageUrl: this.hostUrl + 'api/Virtualization/GetImage',
            uploadUrl: this.hostUrl + 'api/Virtualization/Upload',
            downloadUrl: this.hostUrl + 'api/Virtualization/Download'
        };
        this.view = "Details";
    }

    onBeforeSend(args: any) {
        args.ajaxSettings.beforeSend = function (args: any) {
            args.httpRequest.setRequestHeader('Authorization', 'FileBrowser');
        };
    }
    beforeImageLoad(args: any) {
        args.imageUrl = args.imageUrl + '&rootName=' + 'FileBrowser';
    }
    beforeDownload(args: any) {
        args.data.rootFolderName = 'FileBrowser';
    }
}
@import 'node_modules/@syncfusion/ej2-base/styles/material.css';
@import 'node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import 'node_modules/@syncfusion/ej2-popups/styles/material.css';
@import 'node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import 'node_modules/@syncfusion/ej2-splitbuttons/styles/material.css';
@import 'node_modules/@syncfusion/ej2-navigations/styles/material.css';
@import 'node_modules/@syncfusion/ej2-layouts/styles/material.css';
@import 'node_modules/@syncfusion/ej2-grids/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-base/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-filemanager/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-inputs/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-popups/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-buttons/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-navigations/styles/material.css';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Limitations for Virtualization

  • Programmatic selection using the selectAll method is not supported with virtual scrolling.

  • The keyboard shortcut CTRL+A will only select the files and directories that are currently visible within the viewport, rather than selecting all files and directories in the entire directory tree.

  • Selected file items are not maintained while scrolling, considering the performance of the component.